/*
 - Grammatica.c e' un modulo per la Rappresentazione di una grammatica.
 - Ogni grammatica libera puo' essere codificata in un modulo Grammatica.c
   ed utilizzato con Deriva.
 
 ** AUTHOR: Marco Bellia
 ** LPL - Matematica
 ** Pisa 2016
 
*/
#include <stdlib.h>
#include <string.h>

// NonTerminali
char * NT1 = "S";
char * NT2 = "A";
char * NT3 = "B";

// NonTerminali
char * T1 = "a";
char * T2 = "b";

//produzioni codificate in regole
//S::= A B
//A::= a   -- produzione indice 0 di A
//A::= a A -- produzione indice 1 di A
//B::= b   -- produzione indice 0 di B
//B::= b B -- produzione indice 1 di B
//
bool rules(int index, parseTree newTree){
    //Proprieta' di Deriva: da non usare fuori da deriva
    char * NT = newTree->etichetta;
    if (strcmp(NT,"S")==0){
        newTree->treeKind = 1;
        newTree->sons = cons(makeLeaf(0,"A"),cons(makeLeaf(0,"B"),nil()));
        return true;
    }
    if ((strcmp(NT,"A")==0)&&(index==1)){
        newTree->treeKind = 1;
        newTree->sons = cons(makeLeaf(1,"a"),cons(makeLeaf(0,"A"),nil()));
        return true;
    }
    if (strcmp(NT,"A")==0) {
        newTree->treeKind = 1;
        newTree->sons = cons(makeLeaf(1,"a"),nil());
        return true;
    }
    if ((strcmp(NT,"B")==0)&&(index==1)) {
        newTree->treeKind = 1;
        newTree->sons = cons(makeLeaf(1,"b"),cons(makeLeaf(0,"B"),nil()));
        return true;
    }
    if (strcmp(NT,"B")==0) {
        newTree->treeKind = 1;
        newTree->sons = cons(makeLeaf(1,"b"),nil());
        return true;
    }
    return false;
}
